The m17n Library

Main Page Modules Data Structures Globals Appendix

# Database
[CORE API]

The m17n database and API for it. More...

## Typedefs
typedef struct MDatabase | MDatabase
| Type of database.
## Functions
MDatabase * | mdatabase_find (MSymbol tag0, MSymbol tag1, MSymbol tag2, MSymbol tag3)
| Look for a data in the database.
MPlist * | mdatabase_list (MSymbol tag0, MSymbol tag1, MSymbol tag2, MSymbol tag3)
| Return a data list of the m17n database.
MDatabase * | mdatabase_define (MSymbol tag0, MSymbol tag1, MSymbol tag2, MSymbol tag3, void *(*loader)(MSymbol *, void *), void *extra_info)
| Define a data of the m17n database.
void * | mdatabase_load (MDatabase *mdb)
| Load a data from the database.
MSymbol * | mdatabase_tag (MDatabase *mdb)
| Get tags of a data.
## Variables
char * | mdatabase_dir
| Directory for application specific data.

## Detailed Description

The m17n database and API for it.

The m17n library acquires various kinds of information from data in the m17n database on demand. Application programs can also add/load their original data to/from the m17n database by setting the variable mdatabase_dir to an application-specific directory and storing data in it. Users can overwrite those data by storing preferable data in the directory specified by the environment variable "M17NDIR", or if it is not set, in the directory "~/.m17n.d".

The m17n database contains multiple heterogeneous data, and each data is identified by four tags; TAG0, TAG1, TAG2, TAG3. Each tag must be a symbol.

TAG0 specifies the type of data stored in the database as below.

- If TAG0 is Mchar_table, the data is of the chartable type and provides information about each character. In this case, TAG1 specifies the type of the information and must be Msymbol, Minteger, Mstring, Mtext, or Mplist. TAG2 and TAG3 can be any symbols.

- If TAG0 is Mcharset, the data is of the charset type and provides a decode/encode mapping table for a charset. In this case, TAG1 must be a symbol representing a charset. TAG2 and TAG3 can be any symbols.

- If TAG0 is neither Mchar_table nor Mcharset, the data is of the plist type. See the documentation of the mdatabase_load() function for the details. In this case, TAG1, TAG2, and TAG3 can be any symbols.

The notation <TAG0, TAG1, TAG2, TAG3> means a data with those tags.

Application programs first calls the mdatabase_find() function to get a pointer to an object of the type MDatabase. That object holds information about the specified data. When it is successfully returned, the mdatabase_load() function loads the data. The implementation of the structure MDatabase is concealed from application programs.

## Typedef Documentation

typedef struct MDatabase MDatabase

Type of database.

The type MDatabase is for a database object. Its internal structure is concealed from an application program.

## Function Documentation

MDatabase* mdatabase_define | ( | MSymbol | tag0,
|  | MSymbol | tag1,
|  | MSymbol | tag2,
|  | MSymbol | tag3,
|  | void *(*)(MSymbol *, void *) | loader,
|  | void * | extra_info |
| ) |  |  |

Define a data of the m17n database.

The mdatabase_define() function defines a data that has tags tag0 through tag3 and additional information extra_info.

loader is a pointer to a function that loads the data from the database. This function is called from the mdatabase_load() function with the two arguments tags and extra_info. Here, tags is the array of tag0 through tag3.

If loader is `NULL`, the default loader of the m17n library is used. In this case, extra_info must be a string specifying a filename that contains the data.

Return value:
  If the operation was successful, mdatabase_define() returns a pointer to the defined data, which can be used as an argument to mdatabase_load(). Otherwise, it returns `NULL`.

See Also:
  mdatabase_load(), mdatabase_define()

MDatabase* mdatabase_find | ( | MSymbol | tag0,
|  | MSymbol | tag1,
|  | MSymbol | tag2,
|  | MSymbol | tag3 |
| ) |  |  |

Look for a data in the database.

The mdatabase_find() function searches the m17n database for a data who has tags tag0 through tag3, and returns a pointer to the data. If such a data is not found, it returns `NULL`.

MPlist* mdatabase_list | ( | MSymbol | tag0,
|  | MSymbol | tag1,
|  | MSymbol | tag2,
|  | MSymbol | tag3 |
| ) |  |  |

Return a data list of the m17n database.

The mdatabase_list() function searches the m17n database for data who have tags tag0 through tag3, and returns their list by a plist. The value Mnil in tagn means a wild card that matches any tag. Each element of the plist has key Mt and value a pointer to type MDatabase.

void* mdatabase_load | ( | MDatabase * | mdb | ) |

Load a data from the database.

The mdatabase_load() function loads a data specified in mdb and returns the contents. The type of contents depends on the type of the data.

If the data is of the plist type, this function returns a pointer to plist.

If the database is of the chartable type, it returns a chartable. The default value of the chartable is set according to the second tag of the data as below:

- If the tag is Msymbol, the default value is Mnil.
- If the tag is Minteger, the default value is -1.
- Otherwise, the default value is `NULL`.

If the data is of the charset type, it returns a plist of length 2 (keys are both Mt). The value of the first element is an array of integers that maps code points to the corresponding character codes. The value of the second element is a chartable of integers that does the reverse mapping. The charset must be defined in advance.

See Also:
  mdatabase_load(), mdatabase_define()

MSymbol* mdatabase_tag | ( | MDatabase * | mdb | ) |

Get tags of a data.

The mdatabase_tag() function returns an array of tags (symbols) that identify the data in mdb. The length of the array is four.

## Variable Documentation

char* mdatabase_dir

Directory for application specific data.

If an application program wants to provide a data specific to the program or a data overriding what supplied by the m17n database, it must set this variable to a name of directory that contains the data files before it calls the macro M17N_INIT(). The directory may contain a file "mdb.dir" which contains a list of data definitions in the format described in mdbDir(5).

The default value is NULL.

Top of this page
Main Page Modules Data Structures Globals Appendix